// Class  : ChatTalker, NewChatClient
// Author : Russ Ethington
// Version: 2/16/96 for Java 1.0

import java.io.*;
import java.net.*;
import java.lang.*;

class ChatTalker
{
   public static void main(String args[]) 
   {
      if (args.length < 2)
      {
         System.out.println("Usage: java ChatTalker <HostName> <YourName>");
         return;
      }
      String host = args[0];
      String name = args[1];

      NewChatClient client = new NewChatClient();

      if (!client.dial(host, name))
      {
         System.out.println("No answer...Exiting.");
         return;
      }
      client.chat();
   }
}

class NewChatClient 
{
   SimpleClientConnection me;
   DataInputStream in;
   PrintStream out;
   String outgoing;
   final int port = 4646;

   boolean dial(String host, String name)
   {
      System.out.print("Connecting to " + host + "...");

      try
         {me = new SimpleClientConnection(host, port);}
      catch (IOException e)
      {
         System.out.println("error.");
         System.out.println("Could not create a network connection.");
         return false;
      }

      if (me != null && me.isConnected())
      {
         System.out.println("okay.");
         in = new DataInputStream(System.in);
         out = me.outputStream();;
         out.println(name);
         try
            {out.println(InetAddress.getLocalHost().toString());}
         catch (UnknownHostException e)
            {return false;}
         return true;
      }
      else
      {
         System.out.println("error.");
         System.out.println("Could not connect to '" + host + ":" + port + "'.");
         return false;
      }
   }
   
   void chat()
   {
      System.out.println("Type 'bye' to end chat session.");

      try
      {
         while ((outgoing = in.readLine()) != null)
         {
            if (outgoing.equalsIgnoreCase("bye")) break;
            try
            {
               out.println(outgoing);
               out.flush();
            }
            catch (Exception e) 
            {
               System.out.println("Sorry, your party has hung up.");
               break;
            }
         }
      }
      catch (IOException e) { }
      
      System.out.print("Disconnecting...");
      me.disconnect();
      System.out.println("done.");
   }
}
